﻿using System;

namespace Sudoku
{
    class Program
    {
        static void Main(string[] args)
        {
            Communicator communicator = new Communicator(); //nová instance komunikátora, který zajišťuje IO
            new Solver().Solve(communicator); //nová instance Řešiče, který vřeší sudoku se vstupními daty od komunikátora
            Console.ReadKey(); //program ukončíme po vyřešení stiskem libovolné klávesy
        }

        /*Zdrojový kód programu sestává ze čtyř tříd. Program.cs vše pouze iniciuje a dále již pracují objekty k tomu určené.
         Veškerou komunikaci s uživatelem zajišťuje (přes konzoli) komunikátor (communicator.cs). Řešič (Solver.cs) umí vyřešit
         zadané sudoku a vrátit jej komunikátorovi. Sudoku.cs reprezentuje objekt samotného sudoku a obsahuje některé obslužné
         metody používané řešičem. Dále implementuje IClonable, obsahuje tedy metodu "object Clone()" k vytvoření hluboké kopie.
         Předem upozorním na některé možné nesrovnalosti:
         - k Sudoku.Tabulka[][] (což je ona mřížka na vpisování čísel) přistupujeme do políčka souřadnicemi jako k Tabulka[y][x],
           to je z toho důvodu, že načtené řádky již ukládáme do pole, a protože pozici na řádku vyjadřuje x, je to takto "obráceně"
         - Zdroják je takový česko-anglický. Většinou názvy tříd a metod jsou anglicky, ale interní proměnné česky. Pokud vám to vadí,
           tak se omlouvám.*/
    }
}
